#!/usr/bin/env rdmd

import std.stdio;

class C
{
    @property uint data1, data2;

    this( uint data1 ) {
        this.data1 = data1;
    }

    this( uint data1, uint data2 ) {
        this( data1 );
        this.data2 = data2;
    }
}

struct S
{
    uint data;
}


void main()
{
    C classObj = new C( 0 );
    S structObj;

    C classObj2 = classObj; 
    S structObj2 = structObj;

    ++classObj2.data1;
    ++structObj2.data;

    writefln( "%s %s", &classObj, &classObj2 );
    writefln( "%s %s", classObj.data1, classObj2.data1 );
    writefln( "%s %s", &structObj, &structObj2 );
    writefln( "%s %s", structObj.data, structObj2.data );
}
